﻿using AvaloniaApplicationAdd.Models;
using ReactiveUI;
using System;
using System.Collections.Generic;
using System.Linq;

namespace AvaloniaApplicationAdd.ViewModels
{
    public class MainWindowViewModel : ViewModelBase
    {
        CatBaseContext myConnection = new CatBaseContext();

        string name="";
        DateTime date=DateTime.Now;
        int gender=-1;
        List<string> selectedTraits = new List<string>();

        public string Name { get => name; set => name = value; }
        public string Date { get => date.ToString(); set => date = DateTime.Parse(value); }
        public int Gender { get => gender; set => gender = value; }

        public List<string> Traits 
        { 
            get => myConnection.TraitTables.Select(x => x.Trait).ToList(); 
        }
        public List<string> SelectedTraits 
        { 
            get => selectedTraits; 
            set => this.RaiseAndSetIfChanged(ref selectedTraits,value); 
        }
        public string SelectedTraitCat
        {
            get => null;
            set
            {
                selectedTraits.Add(value);
                SelectedTraits = new List<string>(selectedTraits);
            }
            
        }

        public void addNewCat()
        {
            CatTable newCat = new CatTable()
            {
                Name = name,
                Date = date,
                Gender = gender + 1,
            };
            myConnection.CatTables.Add(newCat);
            myConnection.SaveChanges();

            foreach (string item in selectedTraits)
            {
                TraitTable tc = myConnection.TraitTables.FirstOrDefault(x => x.Trait == item);
                if (tc!=null)
                {
                    TraitCatTable traitCatTable = new TraitCatTable();
                    traitCatTable.IdCat = newCat.Id;
                    traitCatTable.IdTrait = tc.Id;
                    myConnection.TraitCatTables.Add(traitCatTable);
                }
            }
            myConnection.SaveChanges();
        }
    }
}